<?php
/* Paul's webcomic generator script, v 1.0

Sketch drawing component sourced from http://intridea.github.io/sketch.js/

*/

include 'helperfunctions.php';
include 'config.php';

if (isset($_REQUEST['settings'])) die("not allowed to pass settings");

$wrapper = file_get_contents("templates/wrapper.tpl");

if (isset($_REQUEST['action'])) $action = $_REQUEST['action']; else $action = '';

if (isset($_REQUEST['comicid']) && strstr(urldecode($_REQUEST['comicid']), '/')) die("Bad comicid");
if (isset($_REQUEST['name']) && strstr(urldecode($_REQUEST['name']), '/')) die("Bad name, special characters not allowed");
if (isset($_REQUEST['panelid']) && !is_numeric($_REQUEST['panelid'])) die("Bad panelid");
if (isset($_REQUEST['img']) && strstr($_REQUEST['img'], '<'.'?php')) die("Bad img");

$all = ''; $extradocready = '';

if (isset($_REQUEST['filled']) && isset($_REQUEST['action']))
{
 if ($action == 'addcomic')
 {
  $name = $_REQUEST['name'];
  $name = urlencode($name);
  makedirectory("panels/$name");
  $destination = "index.php?action=viewcomic&comicid=$name";
 }
 else if ($action == 'deletecomic')
 { // delete the specified comic
  removedirectory("panels/$name");
  $destination = "index.php";
 } 
 else if ($action == 'savepanel')
 { // add a new panel to the comic or save changes to an existing one, via AJAX post
  $img = $_POST['imgBase64'];
  $img = str_replace('data:image/png;base64,', '', $img);
  $img = str_replace(' ', '+', $img);
  $data = base64_decode($img);
  $comicid = $_REQUEST['comicid'];
  $panelid = $_REQUEST['panelid']; 
  if ($panelid == 0) $panelid = nextpanel($comicid); // starts counting from 1, 0 indicates we're actually adding a panel
  file_put_contents("panels/$comicid/$panelid.png", $data); 
  die();
 }
 else if ($action == 'deletepanel' && $settings['allowalldeletingpanels'])
 { // delete the specified panel
  $comicid = urlencode($_REQUEST['comicid']);
  $panelid = $_REQUEST['panelid'];  
  unlink("panels/$comicid/$panelid.png");
  $destination = "index.php?action=viewcomic&comicid=$comicid";
 }
 header("Location: $destination");
 die('<meta http-equiv="refresh" content="0;url='.$destination.'" />');
}
else
{
 if (!$action) $action = 'listcomics';
 $body = file_get_contents("templates/$action.tpl");
 if ($action == 'viewcomic')
 { // display a specific comic
  $comicid = urlencode($_REQUEST['comicid']);
  $comicname = urldecode($comicid);
  $body = str_replace('{COMICID}', $comicid, $body);
  $body = str_replace('{COMICNAME}', $comicname, $body);
  $bit = limitedtemplateextract($body, '<!-- BEGIN ROW -->', '<!-- END ROW -->');
  $panels = getfiles("panels/$comicid");
  if (!empty($panels))
  {
   sort($panels, SORT_NUMERIC);
   foreach($panels as $panel)
   {
    $panelid = str_replace('.png', '', $panel);
    $one = $bit;
    $panelurl = "panels/".urlencode($comicid)."/$panel";
    if ($settings['allowalleditingpanels']) $panelurl .= '?t='.time(); // stop panel images from caching
    $one = str_replace('{PANELURL}', $panelurl, $one); // not sure why we have to double urlencode $comicid
    $one = str_replace('{PANELID}', $panelid, $one);
    $all .= $one;
   }
  }
  $body = str_replace($bit, $all, $body);
 }
 else if ($action == 'editpanel' && $settings['allowalleditingpanels'])
 { // view a specific panel within a comic for editing
  $comicid = urlencode($_REQUEST['comicid']);
  $comicname = urldecode($comicid);
  $panelid = $_REQUEST['panelid'];  
  $body = str_replace('{COMICID}', $comicid, $body);
  $body = str_replace('{COMICNAME}', $comicname, $body);
  $body = str_replace('{PANELID}', $panelid, $body);
  $extradocready = 'loadsketch("panels/'.urlencode($comicid).'/'.$panelid.'.png");'; // no idea why we need the double urlencode
 }
 else 
 { // show list of available comics and options to start a new one
  $bit = limitedtemplateextract($body, '<!-- BEGIN ROW -->', '<!-- END ROW -->');
  $comics = getsubdirectories("panels");
  if (!empty($comics))
  {
   foreach($comics as $comic)
   {
    $one = $bit;
    $one = str_replace('{COMICID}', $comic, $one);
    $one = str_replace('{COMICNAME}', urldecode($comic), $one);
    $all .= $one;
   }
  }
  $body = str_replace($bit, $all, $body);  
 }
}

if (strstr($body, 'colors_sketch'))
{
 $wrapper = str_replace('</head>', "<script type=\"text/javascript\">
  $(function() {
    $.each(['#f00', '#ff0', '#0f0', '#0ff', '#00f', '#f0f', '#000', '#fff'], function() {
      $('.tools').append(\"<a href='#colors_sketch' data-color='\" + this + \"' style='width: 10px; background: \" + this + \";'></a> \");
    });
    $.each([3, 5, 10, 15], function() {
      $('.tools').append(\"<a href='#colors_sketch' data-size='\" + this + \"' style='background: #ccc'>\" + this + \"</a> \");
    });
    $('#colors_sketch').sketch();
    ".$extradocready."
  });
  
function savesketch(redir)
{
 var canvas = document.getElementById('colors_sketch');
 var dataurl = canvas.toDataURL();
 var comicid = $('#comicid').val();
 if ($('#panelid').length) var panelid = $('#panelid').val(); else var panelid = 0;
 $.ajax({
  type: 'POST',
  url: 'index.php',
  data: { filled: '1', action: 'savepanel', comicid: comicid, panelid: panelid, imgBase64: dataurl }
}).done(function(o) {
  if (typeof redir == 'undefined') location.reload();
  else window.location.href = redir;
});
}

function loadsketch(filename)
{
 var canvas = document.getElementById('colors_sketch'); 
 var context = canvas.getContext('2d');
 var imageObj = new Image();
 imageObj.onload = function(){ context.drawImage(imageObj, 0, 0); };
 imageObj.src = filename; 
 // for undetermined reasons, the image disappears after mouseover -- sketch.js clears the canvas. how to stop the clear?
}
</script>
</head>", $wrapper);
}
$page = str_replace('<!-- BODY GOES HERE -->', $body, $wrapper);

if ($settings['allowalleditingpanels']) $canedit = 1; else $canedit = 0;
if ($settings['allowalldeletingpanels']) $candelete = 1; else $candelete = 0;
$page = str_replace('{CANEDIT}', $canedit, $page);
$page = str_replace('{CANDELETE}', $candelete, $page);
$page = preg_replace('/'.preg_quote('<IF ').'(.*?)'.preg_quote('>').'/', '<'.'?php if ($1) { ?'.'>', $page);
$page = str_replace('</IF>', '<'.'?php } ?'.'>', $page);
 
$questMark = "?";
$phpOpenTag = "<${questMark}php";
$phpCloseTag = "${questMark}>";
eval("$phpCloseTag" . $page . "$phpOpenTag ");  
 
function nextpanel($comicid)
{
 $panels = getfiles("panels/$comicid");
 $r = 0;
 if (!empty($panels))
 {
  foreach($panels as $panel)
  { // we can't just count the number of panels because there may be deleted panels so it doesn't have to be sequential
   $panelid = str_replace('.png', '', $panel);
   if ($panelid > $r) $r = $panelid;
  }
 }
 return $r + 1;
}

?>